diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 5aebf2d570b..6fad4d3fe52 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -124,22 +124,18 @@ static inline JoystickImpl *impl_from_unix_joystick(struct unix_joystick *ptr)
 }
 
 typedef struct _EffectImpl {
-    IDirectInputEffect IDirectInputEffect_iface;
-    LONG ref;
-
     JoystickImpl *device;
     FFEffectObjectReference effect;
-    GUID guid;
-
-    struct list entry;
 } EffectImpl;
 
-static EffectImpl *impl_from_IDirectInputEffect(IDirectInputEffect *iface)
+static inline EffectImpl *impl_from_unix_effect(struct unix_effect *ptr)
 {
-    return CONTAINING_RECORD(iface, EffectImpl, IDirectInputEffect_iface);
+    return (EffectImpl *)ptr;
+}
+static inline struct unix_effect *unix_effect_from_impl(EffectImpl *This)
+{
+    return (struct unix_effect *)This;
 }
-
-static const IDirectInputEffectVtbl EffectVtbl;
 
 static const GUID DInput_Wine_OsX_Joystick_GUID = { /* 59CAD8F6-E617-41E2-8EB7-47B23EEEDC5A */
   0x59CAD8F6, 0xE617, 0x41E2, {0x8E, 0xB7, 0x47, 0xB2, 0x3E, 0xEE, 0xDC, 0x5A}
@@ -938,8 +934,8 @@ static HRESULT CDECL unix_joystick_ff_set_autocenter(struct unix_joystick *ptr,
 static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD value);
 static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD flags);
 
-static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *params,
-        struct list *entry, IDirectInputEffect **out);
+static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, DWORD type, const DIEFFECT *params,
+        const struct unix_effect_vtbl **vtbl, struct unix_effect **out);
 
 static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff);
 
@@ -960,6 +956,29 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     unix_joystick_poll,
 };
 
+static HRESULT CDECL unix_effect_get_parameters(struct unix_effect *ptr, DIEFFECT *effect, DWORD flags);
+static HRESULT CDECL unix_effect_set_parameters(struct unix_effect *ptr, const DIEFFECT *effect, DWORD flags);
+static HRESULT CDECL unix_effect_start(struct unix_effect *ptr, DWORD iterations, DWORD flags);
+static HRESULT CDECL unix_effect_stop(struct unix_effect *ptr);
+static HRESULT CDECL unix_effect_get_status(struct unix_effect *ptr, DWORD *flags);
+static HRESULT CDECL unix_effect_download(struct unix_effect *ptr);
+static HRESULT CDECL unix_effect_unload(struct unix_effect *ptr);
+static HRESULT CDECL unix_effect_escape(struct unix_effect *ptr, DIEFFESCAPE *escape);
+static void CDECL unix_effect_destroy(struct unix_effect *ptr);
+
+static const struct unix_effect_vtbl unix_effect_vtbl =
+{
+    unix_effect_get_parameters,
+    unix_effect_set_parameters,
+    unix_effect_start,
+    unix_effect_stop,
+    unix_effect_get_status,
+    unix_effect_download,
+    unix_effect_unload,
+    unix_effect_escape,
+    unix_effect_destroy,
+};
+
 static INT find_joystick_devices(void)
 {
     static INT joystick_devices_count = -1;
@@ -1146,7 +1165,6 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
     get_osx_device_name(This->id, name, MAX_PATH);
     TRACE("Name %s\n",name);
 
-    list_init(&This->generic.ff_effects);
     if (get_ff(device, &This->ff) == S_OK)
     {
         *has_ff = TRUE;
@@ -1236,26 +1254,21 @@ static CFUUIDRef effect_win_to_mac(const GUID *effect)
     return 0;
 }
 
-static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *params,
-        struct list *entry, IDirectInputEffect **out)
+static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, DWORD type, const DIEFFECT *params,
+        const struct unix_effect_vtbl **vtbl, struct unix_effect **out)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
     EffectImpl *effect;
     HRESULT hr;
 
-    TRACE("(%p)->(%s %p %p %p)\n", This, debugstr_guid(guid), params, entry, out);
-    dump_DIEFFECT(params, guid, 0);
+    TRACE("(%p)->(%s %p %p)\n", This, debugstr_guid(guid), params, out);
 
     if(!This->ff){
         TRACE("No force feedback support\n");
-        *out = NULL;
         return DIERR_UNSUPPORTED;
     }
 
-    effect = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(*This));
-    effect->IDirectInputEffect_iface.lpVtbl = &EffectVtbl;
-    effect->ref = 1;
-    effect->guid = *guid;
+    if (!(effect = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(*effect)))) return DIERR_OUTOFMEMORY;
     effect->device = This;
 
     /* Mac's FFEFFECT and Win's DIEFFECT are binary identical. */
@@ -1267,10 +1280,10 @@ static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFG
         return hr;
     }
 
-    *out = &effect->IDirectInputEffect_iface;
-
     TRACE("allocated effect: %p\n", effect);
 
+    *vtbl = &unix_effect_vtbl;
+    *out = unix_effect_from_impl(effect);
     return S_OK;
 }
 
@@ -1337,137 +1350,69 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     IDirectInputDevice8WImpl_GetImageInfo
 };
 
-static HRESULT WINAPI effect_QueryInterface(IDirectInputEffect *iface,
-        const GUID *guid, void **out)
-{
-    EffectImpl *This = impl_from_IDirectInputEffect(iface);
-
-    TRACE("%p %s %p\n", This, debugstr_guid(guid), out);
-
-    if(IsEqualIID(guid, &IID_IUnknown) || IsEqualIID(guid, &IID_IDirectInputEffect)){
-        *out = iface;
-        IDirectInputEffect_AddRef(iface);
-        return S_OK;
-    }
-
-    return E_NOINTERFACE;
-}
-
-static ULONG WINAPI effect_AddRef(IDirectInputEffect *iface)
-{
-    EffectImpl *This = impl_from_IDirectInputEffect(iface);
-    ULONG ref = InterlockedIncrement(&This->ref);
-    TRACE("%p, ref is now: %u\n", This, ref);
-    return ref;
-}
-
-static ULONG WINAPI effect_Release(IDirectInputEffect *iface)
-{
-    EffectImpl *This = impl_from_IDirectInputEffect(iface);
-    ULONG ref = InterlockedDecrement(&This->ref);
-    TRACE("%p, ref is now: %u\n", This, ref);
-
-    if(!ref){
-        list_remove(&This->entry);
-        FFDeviceReleaseEffect(This->device->ff, This->effect);
-        HeapFree(GetProcessHeap(), 0, This);
-    }
-
-    return ref;
-}
-
-static HRESULT WINAPI effect_Initialize(IDirectInputEffect *iface, HINSTANCE hinst,
-        DWORD version, const GUID *guid)
-{
-    EffectImpl *This = impl_from_IDirectInputEffect(iface);
-    TRACE("%p %p 0x%x, %s\n", This, hinst, version, debugstr_guid(guid));
-    return S_OK;
-}
-
-static HRESULT WINAPI effect_GetEffectGuid(IDirectInputEffect *iface, GUID *out)
+static void CDECL unix_effect_destroy(struct unix_effect *ptr)
 {
-    EffectImpl *This = impl_from_IDirectInputEffect(iface);
-    TRACE("%p %p\n", This, out);
-    *out = This->guid;
-    return S_OK;
+    EffectImpl *This = impl_from_unix_effect(ptr);
+    FFDeviceReleaseEffect(This->device->ff, This->effect);
+    HeapFree(GetProcessHeap(), 0, This);
 }
 
-static HRESULT WINAPI effect_GetParameters(IDirectInputEffect *iface,
-        DIEFFECT *effect, DWORD flags)
+static HRESULT CDECL unix_effect_get_parameters(struct unix_effect *ptr, DIEFFECT *effect, DWORD flags)
 {
-    EffectImpl *This = impl_from_IDirectInputEffect(iface);
+    EffectImpl *This = impl_from_unix_effect(ptr);
     TRACE("%p %p 0x%x\n", This, effect, flags);
     return osx_to_win32_hresult(FFEffectGetParameters(This->effect, (FFEFFECT*)effect, flags));
 }
 
-static HRESULT WINAPI effect_SetParameters(IDirectInputEffect *iface,
-        const DIEFFECT *effect, DWORD flags)
+static HRESULT CDECL unix_effect_set_parameters(struct unix_effect *ptr, const DIEFFECT *effect, DWORD flags)
 {
-    EffectImpl *This = impl_from_IDirectInputEffect(iface);
+    EffectImpl *This = impl_from_unix_effect(ptr);
     TRACE("%p %p 0x%x\n", This, effect, flags);
-    dump_DIEFFECT(effect, &This->guid, flags);
     return osx_to_win32_hresult(FFEffectSetParameters(This->effect, (FFEFFECT*)effect, flags));
 }
 
-static HRESULT WINAPI effect_Start(IDirectInputEffect *iface, DWORD iterations,
-        DWORD flags)
+static HRESULT CDECL unix_effect_start(struct unix_effect *ptr, DWORD iterations, DWORD flags)
 {
-    EffectImpl *This = impl_from_IDirectInputEffect(iface);
+    EffectImpl *This = impl_from_unix_effect(ptr);
     TRACE("%p 0x%x 0x%x\n", This, iterations, flags);
     return osx_to_win32_hresult(FFEffectStart(This->effect, iterations, flags));
 }
 
-static HRESULT WINAPI effect_Stop(IDirectInputEffect *iface)
+static HRESULT CDECL unix_effect_stop(struct unix_effect *ptr)
 {
-    EffectImpl *This = impl_from_IDirectInputEffect(iface);
+    EffectImpl *This = impl_from_unix_effect(ptr);
     TRACE("%p\n", This);
     return osx_to_win32_hresult(FFEffectStop(This->effect));
 }
 
-static HRESULT WINAPI effect_GetEffectStatus(IDirectInputEffect *iface, DWORD *flags)
+static HRESULT CDECL unix_effect_get_status(struct unix_effect *ptr, DWORD *flags)
 {
-    EffectImpl *This = impl_from_IDirectInputEffect(iface);
+    EffectImpl *This = impl_from_unix_effect(ptr);
     TRACE("%p %p\n", This, flags);
     return osx_to_win32_hresult(FFEffectGetEffectStatus(This->effect, (UInt32*)flags));
 }
 
-static HRESULT WINAPI effect_Download(IDirectInputEffect *iface)
+static HRESULT CDECL unix_effect_download(struct unix_effect *ptr)
 {
-    EffectImpl *This = impl_from_IDirectInputEffect(iface);
+    EffectImpl *This = impl_from_unix_effect(ptr);
     TRACE("%p\n", This);
     return osx_to_win32_hresult(FFEffectDownload(This->effect));
 }
 
-static HRESULT WINAPI effect_Unload(IDirectInputEffect *iface)
+static HRESULT CDECL unix_effect_unload(struct unix_effect *ptr)
 {
-    EffectImpl *This = impl_from_IDirectInputEffect(iface);
+    EffectImpl *This = impl_from_unix_effect(ptr);
     TRACE("%p\n", This);
     return osx_to_win32_hresult(FFEffectUnload(This->effect));
 }
 
-static HRESULT WINAPI effect_Escape(IDirectInputEffect *iface, DIEFFESCAPE *escape)
+static HRESULT CDECL unix_effect_escape(struct unix_effect *ptr, DIEFFESCAPE *escape)
 {
-    EffectImpl *This = impl_from_IDirectInputEffect(iface);
+    EffectImpl *This = impl_from_unix_effect(ptr);
     TRACE("%p %p\n", This, escape);
     return osx_to_win32_hresult(FFEffectEscape(This->effect, (FFEFFESCAPE*)escape));
 }
 
-static const IDirectInputEffectVtbl EffectVtbl = {
-    effect_QueryInterface,
-    effect_AddRef,
-    effect_Release,
-    effect_Initialize,
-    effect_GetEffectGuid,
-    effect_GetParameters,
-    effect_SetParameters,
-    effect_Start,
-    effect_Stop,
-    effect_GetEffectStatus,
-    effect_Download,
-    effect_Unload,
-    effect_Escape
-};
-
 #else /* HAVE_IOHIDMANAGERCREATE */
 
 const struct dinput_device joystick_osx_device = {
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 44d8731bdb1..4e5b3eaa245 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -33,6 +33,21 @@
 #define MAX_PROPS 164
 struct JoystickGenericImpl;
 
+struct unix_effect;
+
+struct unix_effect_vtbl
+{
+    HRESULT (CDECL *get_parameters)(struct unix_effect *ptr, DIEFFECT *effect, DWORD flags);
+    HRESULT (CDECL *set_parameters)(struct unix_effect *ptr, const DIEFFECT *effect, DWORD flags);
+    HRESULT (CDECL *start)(struct unix_effect *ptr, DWORD iterations, DWORD flags);
+    HRESULT (CDECL *stop)(struct unix_effect *ptr);
+    HRESULT (CDECL *get_status)(struct unix_effect *ptr, DWORD *flags);
+    HRESULT (CDECL *download)(struct unix_effect *ptr);
+    HRESULT (CDECL *unload)(struct unix_effect *ptr);
+    HRESULT (CDECL *escape)(struct unix_effect *ptr, DIEFFESCAPE *escape);
+    void (CDECL *destroy)(struct unix_effect *ptr);
+};
+
 struct unix_joystick;
 
 struct unix_joystick_vtbl
@@ -52,7 +67,7 @@ struct unix_joystick_vtbl
 
     HRESULT (CDECL *list_effects)(struct unix_joystick *ptr, DWORD type, const GUID **guids, DWORD size, DWORD *count);
     HRESULT (CDECL *get_effect_info)(struct unix_joystick *ptr, REFGUID guid, DIEFFECTINFOA *diei);
-    HRESULT (CDECL *create_effect)(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect, struct list *entry, IDirectInputEffect **out);
+    HRESULT (CDECL *create_effect)(struct unix_joystick *ptr, REFGUID guid, DWORD type, const DIEFFECT *effect, const struct unix_effect_vtbl **vtbl, struct unix_effect **out);
 
     void (CDECL *poll)(struct unix_joystick *ptr);
 };
@@ -120,6 +135,5 @@ HRESULT WINAPI JoystickWGenericImpl_BuildActionMap(LPDIRECTINPUTDEVICE8W iface,
 HRESULT WINAPI JoystickWGenericImpl_SetActionMap(LPDIRECTINPUTDEVICE8W iface, LPDIACTIONFORMATW lpdiaf, LPCWSTR lpszUserName, DWORD dwFlags) DECLSPEC_HIDDEN;
 
 DWORD typeFromGUID(REFGUID guid) DECLSPEC_HIDDEN;
-void dump_DIEFFECT(LPCDIEFFECT eff, REFGUID guid, DWORD dwFlags) DECLSPEC_HIDDEN;
 
 #endif /* __WINE_DLLS_DINPUT_JOYSTICK_PRIVATE_H */
-- 
2.28.0

>From 2b8c25d5d2049cd167a940cee98f27185c74f56e Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 16:18:11 +0200
Subject: [PATCH 36/39] dinput: Create unix joystick data separately from
 generic.

---
 dlls/dinput/ansi.c                |   2 +-
 dlls/dinput/device_private.h      |   1 +
 dlls/dinput/dinput_private.h      |   5 +-
 dlls/dinput/joystick.c            | 123 ++++++++++++++++++++++++------
 dlls/dinput/joystick_linux.c      | 114 +++++++--------------------
 dlls/dinput/joystick_linuxinput.c | 120 ++++++++---------------------
 dlls/dinput/joystick_osx.c        | 106 ++++++++-----------------
 dlls/dinput/joystick_private.h    |  58 +-------------
 8 files changed, 201 insertions(+), 328 deletions(-)

diff --git a/dlls/dinput/ansi.c b/dlls/dinput/ansi.c
index 81ac24f4d26..da5c52dd3f8 100644
--- a/dlls/dinput/ansi.c
+++ b/dlls/dinput/ansi.c
@@ -103,7 +103,7 @@ static void dideviceinstance_wtoa(const DIDEVICEINSTANCEW *didiw, DIDEVICEINSTAN
     didia->wUsage = didiw->wUsage;
 }
 
-static void dideviceinstance_atow(const DIDEVICEINSTANCEA *didia, DIDEVICEINSTANCEW *didiw)
+void dideviceinstance_atow(const DIDEVICEINSTANCEA *didia, DIDEVICEINSTANCEW *didiw)
 {
     didiw->guidInstance = didia->guidInstance;
     didiw->guidProduct = didia->guidProduct;
diff --git a/dlls/dinput/device_private.h b/dlls/dinput/device_private.h
index d6ce489c3e1..c244550e105 100644
--- a/dlls/dinput/device_private.h
+++ b/dlls/dinput/device_private.h
@@ -94,6 +94,7 @@ extern const IDirectInputDevice8AVtbl direct_input_device_a_vtbl DECLSPEC_HIDDEN
 
 extern HRESULT direct_input_device_alloc(SIZE_T size, const IDirectInputDevice8WVtbl *vtbl, const GUID *guid, WORD vid,
         WORD pid, WORD iid, const DIDEVICEINSTANCEW *info, IDirectInputImpl *dinput, void **out) DECLSPEC_HIDDEN;
+extern void dideviceinstance_atow(const DIDEVICEINSTANCEA *didia, DIDEVICEINSTANCEW *didiw) DECLSPEC_HIDDEN;
 
 extern BOOL get_app_key(HKEY*, HKEY*) DECLSPEC_HIDDEN;
 extern DWORD get_config_key(HKEY, HKEY, const char*, char*, DWORD) DECLSPEC_HIDDEN;
diff --git a/dlls/dinput/dinput_private.h b/dlls/dinput/dinput_private.h
index 41819fbd425..99cc3ce4a1c 100644
--- a/dlls/dinput/dinput_private.h
+++ b/dlls/dinput/dinput_private.h
@@ -55,13 +55,16 @@ extern const IDirectInput8AVtbl direct_input_8_a_vtbl DECLSPEC_HIDDEN;
 typedef struct IDirectInputDeviceImpl IDirectInputDeviceImpl;
 typedef struct JoystickGenericImpl JoystickGenericImpl;
 
+struct unix_joystick_vtbl;
+struct unix_joystick;
+
 /* Function called by all devices that Wine supports */
 struct dinput_device {
     const char *name;
     HRESULT (*enum_deviceA)(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id);
     HRESULT (*enum_deviceW)(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id);
     HRESULT (*create_device)(IDirectInputImpl *dinput, REFGUID rguid, IDirectInputDeviceImpl **out);
-    HRESULT (*create_unix_joystick)(IDirectInputImpl *dinput, REFGUID rguid, JoystickGenericImpl **out);
+    HRESULT (*create_unix_joystick)(REFGUID guid, DWORD version, const struct unix_joystick_vtbl **vtbl, struct unix_joystick **ptr, WORD *vid, WORD *pid, WORD *iid, DIDEVICEINSTANCEA *info);
 };
 
 typedef struct JoystickGenericImpl JoystickGenericImpl;
diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 6768ff5b1be..2e28c0cacee 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -222,6 +222,23 @@ static HRESULT CDECL dinput_unix_effect_alloc(const struct unix_effect_vtbl *uni
     return DI_OK;
 }
 
+typedef struct JoystickGenericImpl
+{
+    struct IDirectInputDeviceImpl base;
+    const struct unix_joystick_vtbl *unix_funcs;
+    struct unix_joystick *unix_ptr;
+
+    ObjProps    props[MAX_PROPS];
+    DIDEVCAPS   devcaps;
+    DIJOYSTATE2 js;     /* wine data */
+    int        *axis_map;               /* User axes remapping */
+    LONG        deadzone;               /* Default dead-zone */
+
+    DWORD ff_autocenter;
+    DWORD ff_gain;
+    struct list ff_effects;
+} JoystickGenericImpl;
+
 static inline JoystickGenericImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W *iface)
 {
     return CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface), JoystickGenericImpl, base);
@@ -505,7 +522,7 @@ static LONG joystick_map_axis(ObjProps *props, int val);
 /******************************************************************************
   *     SetProperty : change input device properties
   */
-HRESULT WINAPI JoystickWGenericImpl_SetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIPROPHEADER ph)
+static HRESULT WINAPI JoystickWGenericImpl_SetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIPROPHEADER ph)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
     DWORD i;
@@ -656,7 +673,7 @@ HRESULT WINAPI JoystickWGenericImpl_SetProperty(LPDIRECTINPUTDEVICE8W iface, REF
     return DI_OK;
 }
 
-HRESULT WINAPI JoystickWGenericImpl_Acquire(LPDIRECTINPUTDEVICE8W iface)
+static HRESULT WINAPI JoystickWGenericImpl_Acquire(LPDIRECTINPUTDEVICE8W iface)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
     HRESULT hr;
@@ -670,7 +687,7 @@ HRESULT WINAPI JoystickWGenericImpl_Acquire(LPDIRECTINPUTDEVICE8W iface)
     return hr;
 }
 
-HRESULT WINAPI JoystickWGenericImpl_Unacquire(LPDIRECTINPUTDEVICE8W iface)
+static HRESULT WINAPI JoystickWGenericImpl_Unacquire(LPDIRECTINPUTDEVICE8W iface)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
     HRESULT hr;
@@ -730,7 +747,17 @@ static void _dump_DIDEVCAPS(const DIDEVCAPS *lpDIDevCaps)
 }
 #undef DEBUG_TYPE
 
-HRESULT WINAPI JoystickWGenericImpl_GetCapabilities(LPDIRECTINPUTDEVICE8W iface, LPDIDEVCAPS lpDIDevCaps)
+static ULONG WINAPI JoystickWGenericImpl_Release(LPDIRECTINPUTDEVICE8W iface)
+{
+    JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
+    const struct unix_joystick_vtbl *unix_funcs = This->unix_funcs;
+    struct unix_joystick *unix_ptr = This->unix_ptr;
+    ULONG ref = IDirectInputDevice2WImpl_Release(iface);
+    if (!ref) unix_funcs->destroy(unix_ptr);
+    return ref;
+}
+
+static HRESULT WINAPI JoystickWGenericImpl_GetCapabilities(LPDIRECTINPUTDEVICE8W iface, LPDIDEVCAPS lpDIDevCaps)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
     int size;
@@ -761,8 +788,8 @@ HRESULT WINAPI JoystickWGenericImpl_GetCapabilities(LPDIRECTINPUTDEVICE8W iface,
 /******************************************************************************
   *     GetObjectInfo : get object info
   */
-HRESULT WINAPI JoystickWGenericImpl_GetObjectInfo(LPDIRECTINPUTDEVICE8W iface,
-        LPDIDEVICEOBJECTINSTANCEW pdidoi, DWORD dwObj, DWORD dwHow)
+static HRESULT WINAPI JoystickWGenericImpl_GetObjectInfo(LPDIRECTINPUTDEVICE8W iface, LPDIDEVICEOBJECTINSTANCEW pdidoi,
+        DWORD dwObj, DWORD dwHow)
 {
     static const WCHAR axisW[] = {'A','x','i','s',' ','%','d',0};
     static const WCHAR povW[] = {'P','O','V',' ','%','d',0};
@@ -787,7 +814,7 @@ HRESULT WINAPI JoystickWGenericImpl_GetObjectInfo(LPDIRECTINPUTDEVICE8W iface,
 /******************************************************************************
   *     GetProperty : get input device properties
   */
-HRESULT WINAPI JoystickWGenericImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPDIPROPHEADER pdiph)
+static HRESULT WINAPI JoystickWGenericImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPDIPROPHEADER pdiph)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
 
@@ -906,7 +933,7 @@ HRESULT WINAPI JoystickWGenericImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REF
     return DI_OK;
 }
 
-HRESULT WINAPI JoystickWGenericImpl_EnumEffects(LPDIRECTINPUTDEVICE8W iface, LPDIENUMEFFECTSCALLBACKW lpCallback,
+static HRESULT WINAPI JoystickWGenericImpl_EnumEffects(LPDIRECTINPUTDEVICE8W iface, LPDIENUMEFFECTSCALLBACKW lpCallback,
         LPVOID pvRef, DWORD dwEffType)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
@@ -944,7 +971,7 @@ static void dieffectinfo_atow(const DIEFFECTINFOA *dieia, DIEFFECTINFOW *dieiw)
     MultiByteToWideChar(CP_ACP, 0, dieia->tszName, -1, dieiw->tszName, sizeof(dieiw->tszName));
 }
 
-HRESULT WINAPI JoystickWGenericImpl_GetEffectInfo(LPDIRECTINPUTDEVICE8W iface, LPDIEFFECTINFOW diei, REFGUID rguid)
+static HRESULT WINAPI JoystickWGenericImpl_GetEffectInfo(LPDIRECTINPUTDEVICE8W iface, DIEFFECTINFOW *diei, REFGUID rguid)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
     DIEFFECTINFOA dieia = {sizeof(dieia)};
@@ -956,7 +983,7 @@ HRESULT WINAPI JoystickWGenericImpl_GetEffectInfo(LPDIRECTINPUTDEVICE8W iface, L
     return hr;
 }
 
-HRESULT WINAPI JoystickWGenericImpl_CreateEffect(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIEFFECT lpeff,
+static HRESULT WINAPI JoystickWGenericImpl_CreateEffect(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIEFFECT lpeff,
         LPDIRECTINPUTEFFECT *ppdef, LPUNKNOWN pUnkOuter)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
@@ -986,7 +1013,7 @@ HRESULT WINAPI JoystickWGenericImpl_CreateEffect(LPDIRECTINPUTDEVICE8W iface, RE
     return DI_OK;
 }
 
-HRESULT WINAPI JoystickWGenericImpl_EnumCreatedEffectObjects(LPDIRECTINPUTDEVICE8W iface,
+static HRESULT WINAPI JoystickWGenericImpl_EnumCreatedEffectObjects(LPDIRECTINPUTDEVICE8W iface,
         LPDIENUMCREATEDEFFECTOBJECTSCALLBACK lpCallback, LPVOID pvRef, DWORD dwFlags)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
@@ -1001,7 +1028,7 @@ HRESULT WINAPI JoystickWGenericImpl_EnumCreatedEffectObjects(LPDIRECTINPUTDEVICE
     return DI_OK;
 }
 
-HRESULT WINAPI JoystickWGenericImpl_GetForceFeedbackState(LPDIRECTINPUTDEVICE8W iface, LPDWORD pdwOut)
+static HRESULT WINAPI JoystickWGenericImpl_GetForceFeedbackState(LPDIRECTINPUTDEVICE8W iface, LPDWORD pdwOut)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
 
@@ -1011,7 +1038,7 @@ HRESULT WINAPI JoystickWGenericImpl_GetForceFeedbackState(LPDIRECTINPUTDEVICE8W
     return This->unix_funcs->ff_get_state(This->unix_ptr, pdwOut);
 }
 
-HRESULT WINAPI JoystickWGenericImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE8W iface, DWORD dwFlags)
+static HRESULT WINAPI JoystickWGenericImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE8W iface, DWORD dwFlags)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
     struct dinput_unix_effect *itr;
@@ -1041,7 +1068,7 @@ HRESULT WINAPI JoystickWGenericImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE
     return This->unix_funcs->ff_send_cmd(This->unix_ptr, dwFlags);
 }
 
-HRESULT WINAPI JoystickWGenericImpl_Poll(LPDIRECTINPUTDEVICE8W iface)
+static HRESULT WINAPI JoystickWGenericImpl_Poll(LPDIRECTINPUTDEVICE8W iface)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
 
@@ -1060,7 +1087,7 @@ HRESULT WINAPI JoystickWGenericImpl_Poll(LPDIRECTINPUTDEVICE8W iface)
   *     GetDeviceState : returns the "state" of the joystick.
   *
   */
-HRESULT WINAPI JoystickWGenericImpl_GetDeviceState(LPDIRECTINPUTDEVICE8W iface, DWORD len, LPVOID ptr)
+static HRESULT WINAPI JoystickWGenericImpl_GetDeviceState(LPDIRECTINPUTDEVICE8W iface, DWORD len, LPVOID ptr)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
 
@@ -1080,10 +1107,8 @@ HRESULT WINAPI JoystickWGenericImpl_GetDeviceState(LPDIRECTINPUTDEVICE8W iface,
     return DI_OK;
 }
 
-HRESULT WINAPI JoystickWGenericImpl_BuildActionMap(LPDIRECTINPUTDEVICE8W iface,
-                                                   LPDIACTIONFORMATW lpdiaf,
-                                                   LPCWSTR lpszUserName,
-                                                   DWORD dwFlags)
+static HRESULT WINAPI JoystickWGenericImpl_BuildActionMap(LPDIRECTINPUTDEVICE8W iface, LPDIACTIONFORMATW lpdiaf,
+        LPCWSTR lpszUserName, DWORD dwFlags)
 {
     static const DWORD object_types[] = { DIDFT_AXIS, DIDFT_BUTTON };
     static const DWORD type_map[] = { DIDFT_RELAXIS, DIDFT_PSHBUTTON };
@@ -1132,10 +1157,8 @@ HRESULT WINAPI JoystickWGenericImpl_BuildActionMap(LPDIRECTINPUTDEVICE8W iface,
     return IDirectInputDevice8WImpl_BuildActionMap(iface, lpdiaf, lpszUserName, dwFlags);
 }
 
-HRESULT WINAPI JoystickWGenericImpl_SetActionMap(LPDIRECTINPUTDEVICE8W iface,
-                                                 LPDIACTIONFORMATW lpdiaf,
-                                                 LPCWSTR lpszUserName,
-                                                 DWORD dwFlags)
+static HRESULT WINAPI JoystickWGenericImpl_SetActionMap(LPDIRECTINPUTDEVICE8W iface, LPDIACTIONFORMATW lpdiaf,
+        LPCWSTR lpszUserName, DWORD dwFlags)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
 
@@ -1356,20 +1379,70 @@ static HRESULT setup_dinput_options(JoystickGenericImpl *This, int default_axis_
     return DI_OK;
 }
 
+static const IDirectInputDevice8WVtbl dinput_joystick_w_vtbl =
+{
+    IDirectInputDevice2WImpl_QueryInterface,
+    IDirectInputDevice2WImpl_AddRef,
+    JoystickWGenericImpl_Release,
+    JoystickWGenericImpl_GetCapabilities,
+    IDirectInputDevice2WImpl_EnumObjects,
+    JoystickWGenericImpl_GetProperty,
+    JoystickWGenericImpl_SetProperty,
+    JoystickWGenericImpl_Acquire,
+    JoystickWGenericImpl_Unacquire,
+    JoystickWGenericImpl_GetDeviceState,
+    IDirectInputDevice2WImpl_GetDeviceData,
+    IDirectInputDevice2WImpl_SetDataFormat,
+    IDirectInputDevice2WImpl_SetEventNotification,
+    IDirectInputDevice2WImpl_SetCooperativeLevel,
+    JoystickWGenericImpl_GetObjectInfo,
+    IDirectInputDevice2WImpl_GetDeviceInfo,
+    IDirectInputDevice2WImpl_RunControlPanel,
+    IDirectInputDevice2WImpl_Initialize,
+    JoystickWGenericImpl_CreateEffect,
+    JoystickWGenericImpl_EnumEffects,
+    JoystickWGenericImpl_GetEffectInfo,
+    JoystickWGenericImpl_GetForceFeedbackState,
+    JoystickWGenericImpl_SendForceFeedbackCommand,
+    JoystickWGenericImpl_EnumCreatedEffectObjects,
+    IDirectInputDevice2WImpl_Escape,
+    JoystickWGenericImpl_Poll,
+    IDirectInputDevice2WImpl_SendDeviceData,
+    IDirectInputDevice7WImpl_EnumEffectsInFile,
+    IDirectInputDevice7WImpl_WriteEffectToFile,
+    JoystickWGenericImpl_BuildActionMap,
+    JoystickWGenericImpl_SetActionMap,
+    IDirectInputDevice8WImpl_GetImageInfo
+};
+
 HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectInputImpl *dinput, REFGUID guid, REFIID iid, void **out)
 {
+    DIDEVICEINSTANCEW didiw = {sizeof(didiw)};
+    DIDEVICEINSTANCEA didia = {sizeof(didia)};
+    const struct unix_joystick_vtbl *unix_funcs;
+    struct unix_joystick *unix_ptr;
     JoystickGenericImpl *This;
     ObjProps props[MAX_PROPS];
     DIOBJECTDATAFORMAT *odf = NULL;
     DIDATAFORMAT *df = NULL;
     HRESULT hr;
+    WORD pid, vid, index;
     const int *default_axes_map;
     int i, j, default_axis_count, prop_count;
     WORD idx, type;
     BOOL has_ff = FALSE;
 
-    if (FAILED(hr = device->create_unix_joystick(dinput, guid, &This)))
+    *out = NULL;
+    if (FAILED(hr = device->create_unix_joystick(guid, dinput->dwVersion, &unix_funcs, &unix_ptr, &vid, &pid, &index, &didia))) return hr;
+    dideviceinstance_atow(&didia, &didiw);
+    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickGenericImpl), &dinput_joystick_w_vtbl, guid, vid, pid, index, &didiw, dinput, (void **)&This)))
+    {
+        unix_funcs->destroy(unix_ptr);
         return hr;
+    }
+    This->base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickGenericImpl*->base.crit");
+    This->unix_funcs = unix_funcs;
+    This->unix_ptr = unix_ptr;
     list_init(&This->ff_effects);
 
     if (This->unix_funcs->get_mapping)
@@ -1405,7 +1478,7 @@ HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectI
     This->js.rglSlider[1] = 0;
     for (i = 0; i < 4; i++) This->js.rgdwPOV[i] = -1;
 
-    if (FAILED(hr = This->unix_funcs->init(This->unix_ptr, props, &prop_count, &has_ff))) goto done;
+    if (FAILED(hr = This->unix_funcs->init(This->unix_ptr, This, props, &prop_count, &has_ff))) goto done;
     memcpy(This->props, props, sizeof(This->props));
 
     if (!(df = HeapAlloc(GetProcessHeap(), 0, c_dfDIJoystick2.dwSize))) goto done;
